library natives;

{$mode objfpc}{$H+}

uses
	SysUtils,
	Windows,
	ModuleUtils,
	jassapi;

const
	TARGET_INSTRUCTION_SIZE = 3;

type
	TPatch = array [0..TARGET_INSTRUCTION_SIZE-1] of Byte;

var
	OperationLimitEnabled: Boolean = True;
	OldMemory: TPatch;
	Patch: TPatch = ($31, $C0, $48);

	pGame: Pointer;
	pTargetInstruction: Pointer;

function j_GetTickCount: Dword; cdecl;
begin
	Result:= GetTickCount();
end;

procedure j_SetOperationLimitEnabled(State: LongBool); cdecl;
var
	Dummy: PtrUInt;
begin
	if State = OperationLimitEnabled then
		exit;

	if not State then begin
		Move(pTargetInstruction^, OldMemory[0], Length(OldMemory));

		WriteProcessMemory(
        	GetCurrentProcess(),
			pTargetInstruction,
			@Patch[0],
			Length(Patch),
			@Dummy
		);
	end
	else begin
		WriteProcessMemory(
        	GetCurrentProcess(),
			pTargetInstruction,
			@OldMemory[0],
			Length(OldMemory),
			@Dummy
		);
	end;

	OperationLimitEnabled:= State;
end;

function j_IsOperationLimitEnabled: LongBool; cdecl;
begin
	Result:= OperationLimitEnabled;
end;

procedure RegisterJassNativeOrRaiseException(Name: PChar; Signature: PChar; Address: Pointer);
begin
	if not RegisterJassNative(Name, Signature, Address) then begin
		raise Exception.CreateFmt(
			'Failed to register native function "%s" with signature "%s".', [
			Name,
			Signature
		]);
	end;
end;

procedure Crash(Error: Exception);
begin
	MessageBoxW(
		0,
		PWideChar(UnicodeString(Error.Message)),
		PWideChar(UnicodeString('Error!')),
		MB_ICONERROR
	);
	raise Error;
end;

begin
	try
		pGame:= GetModule(GetCurrentProcessId(), 'Game.dll').modBaseAddr;
		pTargetInstruction:= pGame + $45F7A1;

		RegisterJassNativeOrRaiseException('GetTickCount', '()I', @j_GetTickCount);
		RegisterJassNativeOrRaiseException('SetOperationLimitEnabled', '(B)V', @j_SetOperationLimitEnabled);
		RegisterJassNativeOrRaiseException('IsOperationLimitEnabled', '()B', @j_IsOperationLimitEnabled);
	except
		on e: Exception do begin
			Crash(e);
		end;
	end;
end.

